require("parallel")

slots <- as.integer(Sys.getenv("NSLOTS"))

## start MPI cluster and retrieve the nodes we are working on.
cl <- makeCluster(slots, type = "PSOCK")

## generate (reproducible) random numbers using standard PRNGs
clusterEvalQ(cl, set.seed(123))
clusterCall(cl, runif, 5)

## Better use a parallel PRNG
clusterSetRNGStream(cl, iseed = 123)
clusterCall(cl, runif, 5)

## eventually shut down the MPI cluster
stopCluster(cl)
